Welcome to WinComposer Help

Overview
WinComposer is an icon composer, that is a program to compose (assemble) icons from various graphic resources. WinComposer is not a real, fully featured icon editor, that is it doesn't provide classical edition tools like those offered by specialized programs or by general graphic programs like Photoshop.

User Interface
WinComposer features an user interface built on the resource importation idea. You import graphic resources from files or from the clipboard and display the results in the Composer panel, the first tab of the application. Those resources, according to their size, are displayed in different icon boxes (16*16, 32*32, 48*48 and 128*128 pixels).
To know more about this.

Graphic Resources
WinComposer imports graphic resources from existing files stored on your hard disk, or from other graphical application through the clipboard. It imports Windows and Macintosh icons, bitmaps, JPEG files, and more.
You can also use the clipboard to cut and paste graphic data from other applications.
To know more about this.

Graphic Outputs
From those pictures displayed in the Composer tab, WinComposer can save in different formats: Macintosh icons, Windows icons (single icons or multiformat icons), bitmap, JPEG.
To know more about this.


User Interface

Introduction
WinComposer offers three tabs:

  • Icon Composer, where the icons are built,
  • Pasteboard, where the program displays all graphic resources opened,
  • Macintosh Palettes, which displays Macintosh system palettes.

See also:
Menus of WinComposer.
Context-Sensitive Menu of WinComposer.


Icon Composer

Introduction
The Icon Composer tab is the main tab of the application. All graphic resources (imported from files stored on the hard disk or placed by a cut-and-paste operation) are displayed in the corresponding slots.
In the example shown above, taken from a Macintosh icon file containing several icon formats, we have icons of 16*12, 16*16, 32*32, 48*48 and 128*128 pixels, and their masks.
WinComposer automatically places the imported graphic resources in the slot corresponding to the original size and, if there are several color depths in the file, only displays the best one.
You can nevertheless see what was really in the file by switching to the Pasteboard. This second tab of WinComposer displays all pictures opened by the program.

Cut-and-Paste
When you use cut-and-paste commands, WinComposer works on the selected slot (displayed with a green frame, see below).
It doesn't check whether the color depth of the pasted picture is better or not than the currently displayed picture.
On the other hand, if the picture you're pasting is bigger than the target slot, WinComposer only displays the upper left region of the picture. Wincomposer doesn't offer resizing or moving functions. Prepare the picture before in a graphic editor.

Icon Selection
The selected slot (displayed with a green frame, see above) is the one used for the numerous functions offered by the Context-Sensitive Menu.

Saving the Composed Icons
When you're satisfied with the composed icons displayed in the Icon Composer tab, you can save them to a file, using the File menu and the Save item. See our page on Target Formats for more information on the options offered.
Beside this saving as a multiformat icon file, you can also save each picture slot as a single image, using the save options of the Context-Sensitive Menu.


Pasteboard

The pasteboard is a working zone which displays all graphic resources opened by MacImage, evene those which are not displayed on the Icon Composer tab, because their color depth is lower or equal to the color depth of a picture already displayed.

In the example above, we have complete series of pictures, in 4 bits/pixel, 8 bits/pixel and 32 bits/pixel, together with their masks. Please compare the Icon COmposer tab, below, which displays only the picture with the best color depth:

The reason of this pasteboard is of course to allow you to find back a picture which may be interesting even if its color depth is lower than a picture displayed on the Icon Composer tab. You can copy the pasteboard to the clipboard and paste its contents in Photoshop or in another graphic editor.


Macintosh Palettes

Introduction
The Macintosh Palettes tab is mainly informative. It displays the three system palettes used on the Macintosh. Against what is done in Windows icons (*.ico files) or more generally in Windows bitmap files (*.bmp files), Macintosh icon files in 16 and 256 colors (4 bits/pixel and 8 bits/pixel) don't contain their own palette, but refer the Macintosh system palettes. There are three such palettes:

16-Color Palette

Special Icon Palette, going to 32 + 2 colors

256-Color Palette

Naturally, this last one is the only one of interest nowadays, because of the evolution of the display hardware (who still displays in 16 colors?). Having this palette at hand may help you to understand how and why an icon, pleasant on a PC, can fade on a Mac, or the other way around.
All three palettes can be copied to the clipboard with the CTRL C command when they are displayed. You can then use the eye-dropper to select the colors you want to use.


WinComposer Menus

Introduction
WinComposer offers a classical menu structure:

  • File Menu
  • Edit Menu
  • Options Menu
  • Help Menu

See also:
Context-Sensitive Menu of WinComposer.


File Menu

The File Menu offers following items:

  • Import
    Import graphic resources to be displayed on the Icon Composer tab
  • Save
    Save the contents of the Icon Composer tab into a single file (Grouped Saving)
  • Printer Setup
    Select and set-up the printer to be used as default
  • Print
    Print the contents of the current tab to the default printer
  • Quit
    Close the program and return to Windows

See also:
Edit Menu
Options Menu
Help Menu
Context-Sensitive Menu.


Edit Menu

The Edit Menu offers following items:

  • Cut
    Copy the contents of the selected icon slot to the clipboard and resets its contents.
  • Copy
    Copy the contents of the selected icon slot to the clipboard without resetting its contents.
  • Paste
    Copy the contents of the clipboard to the selected icon slot
  • Create All Masks
    Create the masks (right icons) for all full-color images (left icons)
  • Wipe Out
    Delete the whole contents of the selected tab (Icon Composer tab or Pasteboard tab)

See also:
File Menu
Options Menu
Help Menu
Context-Sensitive Menu.


Options Menu

The Options Menu offers following items:

  • Language
    To switch from English to French and back.

See also:
File Menu
Edit Menu
Help Menu
Context-Sensitive Menu.


Help Menu

The Help Menu offers following items:

  • Help on Help
    Little help page about the different features of the help system
  • Help Topics
    Access to the main help file (this file)
  • Help Search
    Access to the search function
  • Help Index
    Access to the index function (keywords)
  • On-Line Support
    Access to the main support pages of our site (www.macdisk.com). You have to be connected to use this feature.
  • About WinComposer
    Classical window with the current version, the serial number, etc.

See also:
File Menu
Edit Menu
Options Menu
Context-Sensitive Menu.


Context-Sensitive Menu

Introduction
WinComposer offers a context-sensistive menu, called by a click on the right button of the mouse. Its contents varies according to the context in which it is displayed.

Cut-and-Paste Commands
The cut-and-paste commands behave classically. Cutting puts the contents of the image in the clipboard and clears the icon slot. Copying copies the contents to the clipboard but leaves it unchanged in the icon slot. Pasting pastes the contents of the clipboard to the icon slot.

Color Depth Submenu
The Color depth submenu allows the user to reduce the color depth of the image. This feature is useful to see what this color reduction can do. The color depth reduction is not undoable.
WinComposer doesn't apply sophisticated algorithms to achieve this result, which means that you should do it in a real graphic editor, which would probably yield better results.

Rotation Submenu
The Rotation submenu offers the classical rotation operations (90° to the right and to the left, 180°) as well as the flipping operations (up-down, vertically, and right-left, horizontally).

Color Counting
The color counting feature allows the user to count the number of different colors used to display the selected icon.

Premultiplication
This submenu of the context-sensitive menu allows you to apply the alpha channel (which defines the transparency of the picture) to all three color channels. This operation is called premultiplication. The inverse operation is called demultiplication.
Only use this feature if you precisely know that you have to do it.

Save Image As Submenu
Against the saving function offered in the File Menu, this features only saves the contents of the selected image.

See our page on Individual Saving for more information.

Create Mask
This feature, which is only validated when the icon slot selected is the right icon, allows the user to recompute the mask to be used with the left icon (full color icon).

See also:
WinComposer Main Menu.


Imported Graphic Resources

Input Formats
WinComposer accepts as input following formats:

  • Bitmap Files (*.BMP extension) - For more information
  • JPEG Files (*.JPG or *.JPEG extensions) - For more information
  • Windows Icon Files (*.ICO extension) - For more information
  • Macintosh Icon Containers (*.icns extension) - For more information
  • Macintosh Icon Resources - For more information
  • Apple Single Files - For more information
  • Apple Double Files - For more information
  • Binhexed Files - For more information
  • MacBinary Files - For more information
  • Other Windows Ressources - For more information

Image Size
When scanning the contents of the imported files, WinComposer looks for following formats:

  • 12*16 pixels (so-called Macintosh mini icons)
  • 16*16 pixels (normal icons)
  • 32*32 pixels (big icons)
  • 48*48 pixels (huge icons)
  • 128*128 pixels (thumbnail icons).

It doesn't display other images sizes. If you want to exploit such sizes, use the cut-and-paste mechanism.

Color Depth
When scanning the contents of the imported files, WinComposer displays in the icon slots of the Icon Composer tab the best color depth available in the file for each of the icon sizes.
That means that a 4 bit/pixel picture will not replace a better one.
On the other hand, all color depths are displayed on the Pasteboard tab.

Cut-and-Paste
WinComposer can also import graphic data using the cut-and-paste mechanism. Just select the target icon by clicking on its surface and type CTRL V to paste the contents of the clipboard.
Caution, WinComposer is not a graphic editor. The graphic data get pasted in the upper left corner and can't be resized or moved.
You should therefore prepare correct graphic data in yourfavorite graphic editor.

Bitmap Files (*.BMP extension)
WinComposer accepts all bitmap formats, in all color depths (1, 4, 8, 24 and 32 bit/pixel).
Back to Formats List

JPEG Files (*.JPG or *.JPEG extensions)
WinComposer accepts all JPEG formats as input. Since this standard leaves many freedom degrees, one can't however be sure that all files will correctly open. It may sometimes be necessary to go through the cut-and-paste mechanism from a graphic application which knows how to open this file.
Back to Formats List

Windows Icon Files (*.ICO extension)
WinComposer accepts all icon formats, that is files containg a single icon or several icons (multiformat icon files) in all color depths, up to 128*128 pixels.
Back to Formats List

Macintosh Icon Containers (*.icns extension)
The 'icns' icon format was launched with Mac OS 8 and, against other classical icon resources (see below), is not a single icon object, but a container grouping together several sizes and color depths, with their masks.
See our page on Macintosh Icon Resources for more information.
Back to Formats List

Macintosh Icon Resources (varying or no extensions)
Classical Macintosh icon resources are stored in the Resource Fork, as individual icon items.
It is possible to find in the resource fork all kinds of icons, but most of the time the modern icon resources are stored in 'icns' containers (see above). Those containers can be stored themselves in the resource fork or in stand-alone files (Mac OS X).
See our page on Macintosh Icon Resources for more information.
Back to Formats List

Apple Single Files
The Apple Single format is a method normalized by Apple to keep together (containerize) both File Forks. Both forks are present in the file. The very nature of the containerized file (payload) can vary.
See our pages on Forks and on Macintosh Files on the Internet for more information.
Back to Formats List

Apple Double Files
The Apple Double format is a method normalized by Apple to manage File Forks. Only the resource fork is present in the file with the Finder info. The data fork is in another file. The very nature of the containerized file (payload) can vary.
See our pages on Forks and on Macintosh Files on the Internet for more information.
Back to Formats List

BinHexed Files
The BinHex standard was created to allow the containerization of File Forks, some compression of the stream and the conversion to 7-bit characters. Both forks are present in the file. The very nature of the containerized file (payload) can vary.
See our pages on Forks and on Binhexed Files for more information.
Back to Formats List

MacBinary Files (*.BIN extension, but not always)
The MacBinary standard was created to keep together (containerize) both File Forks. Both forks are present in the file. The very nature of the containerized file (payload) can vary.
See our pages on Forks and on MacBinary Files for more information.
Back to Formats List

Other Windows Resources (*.EXE, *.DLL and *.IDL extensions, and more)
WinComposer can also open Windows resources to extract bitmaps and icons from those files. WinComposer manages program files (*.EXE), DLLs (*.DLL) and icon libraries (*.ICL, but also *.IL and *.NIL).
Back to Formats List


Graphic Output

Introduction
WinComposer can save the imported graphic resources in several formats.

Multiple Icon Files or Single Icon Files?
Depending on the future use of the saved files, you may need a file holding several icons, with several sizes and several color depths, or a file holding a single icon (in a single size and a single color depth).

To go further:

  • Individual Saving (from the context-sensitive menu)
  • Grouped Saving (from the 'Saving' item in the File Menu)


BinHex Format

Introduction
The BinHex format was created to meet two specific needs. First, it encodes binary data as ASCII characters (which use 7 bits) into binary files (which use 8 bits) and can be sent on the Internet. Second, it bundles into a single container both forks that compose a Macintosh file. Finally, the author, Yves Lempereur, added the RLE compression function to avoid sending repetitive sequences of identical characters.

How to identify a binhexed file
The suffix used for binhexed files is generally HQX. The signature of these files (on an HFS medium) is TEXTBNHQ.
Moreover, the first line of a BinHex file is:

(This file must be converted with BinHex 4.0)

You have only to open the file in a word processor to ascertain that the file you received is indeed a BinHex file. Please note that, according to the specs, this comment line is not mandatory, but that all utilities we have used put this line at the beginning of the file. The BinHex standard also specifies that the first and last character of the data stream should be a double quote.
We have seen files where the line above was not the first one, but the second one. Our programs ‘choke’ on such files. Open them in a text-editor and delete the first line.

When can you get binhexed files?
The BinHex standard is one of the working modes (with mime) of most Macintosh mail software. These packages encode and decode the data stream automatically, and most users never know they are using binhexed files. Things are different when a Macintosh user sends a file to a PC user. Some mail packages on the PC don’t know the BinHex standard and just store the coded file on the hard disk.
The BinHex format is also used by some programs to build Macintosh files on other platforms. That is what Flash (Macromedia) does when asked to build a Macintosh animation. In this case, the BinHex coding plays the same role as the MacBinary coding, since the 7-bit coding is technically irrelevant.

How to decode binhexed files on the PC
There are several utilities for decoding binhexed files on the PC. They generally have some shortcomings, mostly because of the very nature of Macintosh files. The main shortcomings are:

  • The original Macintosh filename is lost.
  • The signature of the Macintosh file is not recognized.
  • The contents of the resource fork is lost.

On the other hand, our programs know BinHex files and manage them correctly.


Custom Icons

Introduction
The Macintosh allows adding so-called custom icons to volumes (disks), folders and files. Those custom icons are displayed by the Finder instead of the usual icons offered by the operating system or by the application used to create/edit the files.
In the case of files, this custom icon is used to better show the data contents of the file.
With folders (the volume/disk is only a special case and gets the icon of the root folder), this custom icon illustrates the contents (files and subfolders), or can represent the producer/author of the data.

How To Do On the Macintosh?
The classical method, on the Macintosh, is to display the file or folder information and to paste in the displayed icon an image copied from a graphic application.

How To Do With MacImage?
MacImage is bundled with a specialized module named WinComposer. This module allows the user to import numerous graphic resources (Windows icons, Macintosh icons, several other graphic formats) to produce icons in 16*16, 32*32, 48*48 and 128*128 pixels.
The multiformat icon produced by WinComposer (saved as a Resource Fork stored in MacBinary container) is simply included in the folder (MacImage automatically unpacks the MacBinary container) and the checkbox 'Custom Icon' is checked in the 'Properties' window of the folder.
The sames applies for volumes (the file is stored in the Root Folder). However, since Mac OS X doesn't use the same scheme for volume custom icons, you'll have to include the classical resource icon for Mac OS 9 and below, and a special data fork icon named '.VolumeIcon.icns' for Mac OS X.
Those icon files must be hidden. In the case of the MacBinary container, WinComposer sets itself this flag in the MacBinary header. In the case of the data fork icon, you'll have to set this flag yourself in the Properties window.
This feature is not yet supported in the case of files.

Technical Aspects
Technically, the matter is not very complicated. Custom icons are normal icon resources, but must bear the "magical" -16455 identification number. More, the "custom icon" flag of the folder record must be set.
In the case of files, the same graphic resources must be stored in the resource fork of the file. This time, the flag is set in the file record.
Those icon resources are not stored by the Finder in its database (Desktop).

Folder Custom Icons
The folder (the root folder for the volume) must contain a hidden file named "icon\r" (0x0D as the last character) holding correct graphic resources (see the page on Macintosh Icons in WinComposer help for more technical information).

Volume Custom Icons
Under Mac OS 9 and below, the Root Folder is treated like a normal folder, and should contain the same 'icon\r' file.
Under Mac OS X, the file holding the icon must be named '.VolumeIcon.icns' and the icon format must be an 'icns' resource. This resource is stored in the data fork.
If you target all versions of the Macintosh operating system, you may include both files. Older versions won't do anything with the '.VolumeIcon.icns' file. Under Mac OS X, all files beginning with a dot are (like under Unix) treated as system and hidden files. This is not the case under Mac OS 9 and below. You should therefore hiden those files to avoid perplexity amongst users.


MacBinary Format

MacBinary files
The MacBinary de facto standard (specs. of versions I, II and III can be found at Lazerware but should interest only programmers) allows both forks of Macintosh files to be kept together on telecommunications lines or on servers which don’t know anything about forks. A MacBinary file (SEA archives are only a special case) contains three parts:

  • Finder header (length 128 bytes)
  • Data fork (variable length)
  • Resource fork (variable length, beginning on the next block of 128 bytes)

When you download a Macintosh file from a server, be it a data file, a program file or an archive, you generally download a MacBinary file (See also our page on binhexed files). If you download it to a PC, you have to manage the parts and put them where they belong.

Reinstalling a MacBinary file on a Macintosh volume
The procedure for reinstalling the MacBinary file onto a Macintosh medium is pretty simple. Here are the instructions for using MacDisk to transfer the file to a Macintosh disk. See below for instructions with MacImage.
1. Take a Macintosh floppy or format one with MacDisk (remember you can use quick reformatting on a clean 1.44 MB PC diskette).
2. Click on the ‘PC to Mac’ button.
3. Select the file in the dialog box and start the copy. MacDisk automatically detects MacBinary files.
You will note that the file, on the Macintosh medium, doesn’t necessarily have the same name as on the MS-DOS medium. That is because the original filename was stored in the Finder header and MacDisk has restored it. You will also observe that a part of the file has been put in the data fork and another part in the resource fork.
If you mount the medium on a Macintosh, you should get a double-clickable application.

Including MacBinary files in a project under MacImage
When you include a MacBinary file in a project, MacImage identifies the format and looks for all details within the file. The process is quite transparent. You don't have anything special to do.


Macintosh File Forks

File Forks
Under the Macintosh file system, files do not consist of one single segment. They are composed of two pieces, called forks, i.e. a data fork and a resource fork. Only one of these two forks may be empty.

Data Fork
The data fork contains what is generally called a file on the PC, for instance, the text created by a word processor or the pixels composing a picture, etc. When data files are transferred between a Macintosh and a PC, the data fork is the only part of interest (the only exceptions are font files and applications/programs).
If a Macintosh data file has lost its resource fork, for instance after being transferred through another file system, it remains fully usable, even if it is not recognized by the Finder and no longer double-clickable (because it has lost its signature). Just launch the application and open it with File | Open.

Resource Fork
The resource fork may contain the code of a program or the commands of a font file, etc. Some programs store a preview picture in the resource fork.
Despite what is often said, the resource fork doesn’t contain the signature of Macintosh files (file type and file creator).

Why a Resource Fork?
The resource fork is organised as a database, which allows a fast access to all components of the stream. This is a big advantage for some applications. It is also possible to change some elements without disturbing the rest of the file.

How to Manage Both Forks
Two main methods are commonly used to keep both forks of Macintosh files together on communication lines and on servers which don’t know anything about forks: the MacBinary standard and the BinHex standard.
Apple has also released two specifications, called AppleSingle and AppleDouble, to get a similar result.


Macintosh Signatures

What are signatures?
The Macintosh doesn't use the three-character extension concept (or even more than three, like under Unix and also nowadays under Windows) to identify files, but signatures. Signatures are strings of eight bytes, four for the creator (the program which created the file) and four for the file type (text, picture, and so on).
The correspondance between signatures and icons is managed by the Finder, for all programs which happened to exist on a volume, in the Desktop file (an hidden system file which is never shown by the Macintosh but exists on every disk). With System 7 and upwards, the Desktop graduated to a double Desktop DB + Desktop DF, for reasons which would lead us too far away from our main issue.

Where are signatures stored?
These signatures, contrary to what is often mentioned, even by knowledgeable persons, are not saved in the resource fork of each file, but in the catalog tree (on the disk, in a management structure you will [hopefully] never have to look at).
This mistake finds its origin in the fact that the programs (and only the programs, not the data files) put the icons they use in their resource fork and have to declare (in a bundle resource placed in their resource fork) the signature of the files they intend to manage, so that the Finder knows what to do when the user double-clicks on an icon. Another source of errors comes from the fact that some graphic files save in the resource fork a preview picture of the file (thumb nail to display on the desktop).

Signatures tables
Here are some of the signatures and corresponding PC extensions we collected (if you want to add or correct something, please feel free to send us an e-mail, we update the site almost once a week).
For those who need to edit the internal table of our Mac-PC transfer programs (MacDisk and MacImage), you will have to note the signature/extension you want to use/exploit and put it in the table displayed by the SignEdit utility. If you encounter an atypical file (something not giving the results expected), please check the real signature of a file whose origin doesn't make any doubt, on a Macintosh magnetic volume (see the rightmost column of the display).

Generic formats
These signatures identify the file type, but not the creator ('????' is a valid creator). They are useful when a program refuses to load a file because the signature is not what it expects and the programmer was too lazy to look into the file. We give the PC extension when there is a well established one.

Signature | Extension | Comments
APPL???? |  | Application (program)
EPSF???? | EPS | Generic EPS
JPEG???? | JPG | Generic JPEG
PICT???? | PCT | Generic Pict
TEXT???? | TXT | Generic Text
TIFF???? | TIF | Generic TIFF

Specific formats
These signatures identify both the file type and the creator. Applications other than the creator generally only look at the file type to ascertain whether they can open the file.

Signature | Extension | Comments
8BIM8BIM | PSD | Photoshop 3/4 files
8BIM8BPS | PSD | Photoshop
ALB4ALD4 | PM4 | Pagemaker 4
ALB5ALD5 | PM5 | Pagemaker 5
ALB6ALD6 | PM6 | Pagemaker 6
APPLaust |  | Self-extracting archive created by Stuffit
APPLEXTR |  | Self-extracting archive created by Compact Pro
AB65AD65 | P65 | Pagemaker 6.5
cDRWdDRW |  | Claris Draw
CWWPBOBO | CWK | Claris Works text v. 1 to 5
dPROdDOC | MDP | MacDraw Pro
DDAPDDFL |  | File compressed by Disk Doubler ??
EPSPXPR3 |  | EPS created by Xpress
FH50AGD1 | FH5 | Freehand 5
FHD3FHA3 | FH3 | Freehand 3
FMP3FMP3 | FMP/FP3 | FileMaker Pro
FXTCEggP | AEP | After Effects' project file
inDdinDn | IND | Indesign Document
LWFNASPF |  | Adobe Type 1 Font
MDPLDRWG |  | MacDraw II files
MDRWDRWG |  | MacDraw files
MV93MD93 | DIR | Macromedia Director
MooVTVOD | MOV | QuickTime files
MW2DMWII |  | Mac Write II
nX^2nX^n |  | WriteNow 3
nX^nnX^n |  | WriteNow 2
PACTCPCT | ??? | Archive created by Compactor (Pro)
PDF_CARO | PDF | Acrobat files (_ being a space)
QSfLQSfl |  | Check file of the Symantec AV
SIT!SIT! | SIT | Archive created by Stuffit
SITDSIT! | SIT | Archive created by Stuffit
SLD3PPT3 | PPT | Power Point 3
SLD8PPT3 | PPT | Power Point 98
StMIGIFf | GIF | GIF files created by PageMill
StMITEXT | HTM | HTML files created by PageMill
TEXTART3 | AI | Illustrator 3
TEXTBNHQ | HQX | BinHex
TEXTOMEG |  | Mathematica (all kinds of files)
W6BNMSWD | DOC | Microsoft Word 6
W8BNMSWD | DOC | Microsoft Word 8 (98)
WDBNMSWD | DOC | Word 3/4/5 Macintosh
WORDBOBO | CWK | Claris Works (word processor)
WORDMACA |  | Mac Write 4.6/5
WP42SSIW | WP4 | Wordperfect 4 (saved by WP for the Mac)
WP50SSIW | WP5 | Wordperfect 5 (idem)
WTBNMSWD | DOT | Word Template
XDOCXPR3 | QXD | Xpress (all versions)
XLBNXCEL | XLS | Excel 1 for the Macintosh
XLS4XCEL | XLS | Excel 4
XLS5XCEL | XLS | Excel 5
ZIP_ZIP_ | ZIP | Zipped archive (_ being a space)

Below a more general list of filetype and creator strings we already saw.

File types
Signature | Comments
..CT | Scitex files (put 8BIM as creator if you want that files open directly in Photoshop when you double-click on them on the Mac
.WP4 | PC WP4 file as seen by Wordperfect 2 for the Mac
.WP5 | PC WP51 file (idem)
8BIM | Adobe Photoshop native format
8BPS | Transparent
AB65 | Pagemaker 6.5
ALB3 | PageMaker 3
ALB4 | PageMaker 4
ALB5 | PageMaker 5
ALB6 | PageMaker 6
AWDB | MS-Works database
AWSS | MS-Works spreadsheet
AWWP | MS-Works word processor file
BINA | Text file saved as Word DOS or Word Windows file by Word Mac 5
CrTC | Project file by Toast 3
CWWP | Claris Works text file
DCT5 | MS-Word dictionnary
DDFL | Disk Doubler data file
dDOC | MacDraw Pro file
dDRW | Claris Draw File
DRWG | MacDraw file
DWG_ | AutoCAD file (_ being a space)
EggP | After Effects' project file
EPSF | EPS file
FFIL | Font Suitcase (Type 1 or True Type)
ffil | Display Font
FH50 | Freehand 5 file
FHD3 | Freehand 3 file
F#+D | Rag Time Classic file
FMK$ | FileMaker 1 file
FMP3 | FileMaker Pro file
GIFf | GIF files created by PageMill
GLOS | MS-Word glossary
HImg | Image file created by Toast 3
inDd | Indesign Document
JPEG | JPEG file
lfil | True Type Font
LWFN | Type 1 Font (PostScript font)
MooV | QuickTime file
MPEG | MPEG file (MPEG1 coding)
MPWd | MacWrite Pro 1.5 file
MW2D | MacWrite II file
MW2S | MacWrite II model
nX^2 | Write Now 3 file
nX^d | Write Now 2 file
PACT | Compactor data file
PDF_ | Acrobat files (_ being a space)
PICT | PICT file
R#+A | RagTime Classic text file
RTF_ | RTF File (the _ being a space)
S#+A | Rag Time 2 text file
SIT! | Stuffit Archive
SITD | Stuffit Archive
SLD3 | PowerPoint 3
SLD8 | PowerPoint 8
TIFF | TIFF file
W6BN | Mac Word 6
W8BN | Mac Word 8 (98)
WDBN | Mac Word 3, 4, 5 text file
WHLP | MS-Word help file
WORD | MacWrite formatted file
WP42 | PC WP4 file seen by Wordperfect 1 for the Mac
WP50 | PC WP51 file seen by Wordperfect 1 for the Mac
WPD0 | Wordperfect 1 text file
WPD1 | Wordperfect 2 text file
WPD3 | Wordperfect 3 text file (what happened to the '2'?)
WPRD | MS-Word print file
WTBN | Word Template
XDOC | Xpress file
XTMP | Xpress template
XLBN | Excel 1 spreadsheet
XLS_ | Excel 2.2 spreadsheet (_ being a space)
XLS3 | Excel 3 spreadsheet
XLS4 | Excel 4 spreadsheet
ZIP_ | Zipped archive (_ being a space)

Creator strings
Signature | Comments
8BIM | Adobe Photoshop
ACAD | AutoCAD
AD65 | Pagemaker 6.5
AGD1 | Freehand 5
ALD3 | PageMaker 3
ALD4 | PageMaker 4
ALD5 | PageMaker 5
ALD6 | PageMaker 6
APLS | ??
ART3 | Illustrator 3
ART5 | Illustrator 5 and later
ARTY | Illustrator 1
ARTZ | Illustrator 88
BOBO | Claris Works
CARO | Acrobat Distiller
CDr3 | Toast v. 3
cDRW | Claris Draw
CPCT | Compactor (Pro ?)
DDAP | Disk Doubler
dPRO | MacDraw Pro
ERIK | Finder (Desktop files)
F#+A | Rag Time Classic
FHA3 | Freehand 3
FMK4 | FileMaker II ?
FMP3 | FileMaker Pro
FXTC | After Effects
inDn | InDesign
MACA | MacWrite 2.2 and 4.6
MDRW | MacDraw
MDPL | MacDraw II
mdos | DOS file copied by AFE or PC Exchange
MOSS | Netscape (Mozilla)
MPWR | MacWrite Pro
MSWD | Microsoft Word 3/4/5 for the Mac
MWII | MacWrite II
nX^n | Write Now v. 3
OMEG | Mathematica
PPT3 | PowerPoint (all versions)
PSIP | Works 1
PSI2 | Works 2
R#+D | Rag Time 3
S#+D | Rag Time 2
SIT! | Stuffit
SSIW | Wordperfect 1
StMI | Adobe PageMill
vgrd | LaserWriter (Postscript file)
WPC2 | Wordperfect 2 (3 also)
XPR3 | QuarkXpress 3
XCEL | Excel

Other sites may be helpful:

  • Signature Page on our Internet site
    This this page is only a copy of the Internet page, you may want to visit the original page, which is updated more frequently.
  • Apple signature registering page
    Signatures [or at least creator strings] should be registered with Apple. This site allows you to consult the database and know whether a string is free or registered. There is no possibility to get a exhaustive list (and Apple stated publicly that there would be no such list).
  • Ilan Szekely's Index
    Index to download, containing more than 30,000 signatures.


Macintosh Files and the Internet

Internet and Macintosh Files
Some comments are in order about how to manage Macintosh files sent through the Internet: files downloaded from servers (through the FTP or HTTP protocol) or files received through email (as attached files).
Two main reasons justify a special treatment. First of all, Macintosh files are not monolithic, but may be composed of two pieces, called forks, i.e. a data fork and a resource fork. Please consult the page on file forks for more details.
Secondly, the nature of a Macintosh file is not expressed as a file extension (or file suffix), but as a signature, a string of characters encoding the file creator and the file type. Again, consult the page on file signatures if you want more details.
Last but not the least, the email protocol doesn’t allow the sending of binary files, but only text files. This means that the bytes of the file are only encoded in 7 bits and not in 8 bits.
This explains why most FTP and mail programs running on the Macintosh silently build containers when asked to upload a file to a server or to send a file as an attachment.

Macintosh Files Attached to E-mail Messages
Most Macintosh mail programs execute silently two different operations on attached files:

  • Containerization (regrouping both forks and the Finder info)
  • Encoding (to allow 8-bit bytes to travel as 7-bit bytes)

However, a PC mail program only encodes the attached files.
When the attached files arrive on the target computer, the mail client has to decode the file, then open or break the container to place all of the pieces where they belong.

De Facto Standards
Four standards are used in this context: MacBinary, AppleSingle, AppleDouble and BinHex. MacBinary and AppleSingle describe a way to put into a single file (called the container) the two forks composing the file, plus some elements like the signature. The resultant file is then encoded in the usual way.
The AppleDouble standard doesn’t put both forks into a single container, but in two separate streams that the MIME mail program can put into a single message. At the other end, the client will decode what it knows (generally only the data fork, just silently dropping the resource fork). Please note that the AppleDouble and AppleSingle formats are a MIME standard (RFC1740).
The Binhex standard holds a special position because it does both operations together, plus some simple data compression (RLE).

What to Do
The first thing to do is to ascertain how the received file was managed.
You can use our MacMail program, whose goal is to try to automate as many of the operations as possible. Please consult its page to know more about it.
Another proven method is to try to open the file in a text editor and to look for some specific strings.
Binhexed files contain the following string in the first line: “(This file must be converted with BinHex 4.0)”.
MacBinary files are not easily recognized because there is no ‘magic’ signature. However, you should find at the beginning (offset 2) the string of the original Macintosh filename. A little further (offset 65) is the signature of the file.
AppleDouble and AppleSingle files should never exist in this form on the target machine, since all recent mail clients should decode them without asking the user. Nevertheless, the ‘magic signature’ of AppleSingle files is 0x00051600 while it is 0x00051607 for AppleDouble files. This signature is to be found at the beginning of the single file in the case of the AppleSingle standard and at the beginning of the header file (file containing everything but the data fork) in the case of the AppleDouble standard.

Fonts: A Special Situation
When fonts are transferred from the Macintosh to the PC as attached files, several situations can arise. If the font has been transferred in AppleDouble or AppleSingle format, your mail client may know these formats and try to decode the file. Since the e-mail client thinks that the only usable part must reside in the data fork and the data fork is empty, the user gets an empty file. The e-mail software generally discards the resource fork without explanation because it may think of this as the only logical way to go, even if you don’t agree.

Fonts in MacBinary or BinHexed Format
You may have a better chance if the font has been sent as a BinHex file or a MacBinary file.
We invite you to visit our page on Fonts Transfers for more information on this subject.

How to send an attached file to a Macintosh user
Some users ask how to send a file created on the PC to a Macintosh user by e-mail.
First of all, if you want to send a Word or Excel file, don’t send the file encoded in the format of the latest version. As a rule of thumb, send Word files only as Word 5 for the Macintosh or Word 2 for Windows, and Excel files as Excel 5. For other text formats, use RTF.
If you send such a file as an attachment, odds are good that the file will display on the Macintosh screen with a generic (cornered sheet) icon, and that the user, when double-clicking this icon, will get an error message about opening this file as SimpleText. The user must first launch the application, then open the File menu and select the item using Open.


Macintosh Icons

Introduction
This page is a rather technical one, on Macintosh icon resources. Since I had a hard time finding out several of those pieces of information, I decided to make them public.

Different Resource Types Used for Icons

Signature | Comments
cicn | Icons for menus and dialogs, color (cicn = color icon), containing a palette, a bitmap and a mask. It can be an icon (32*32) with mask or an icon of any size without mask. The color depth can be specified. See IM:Imaging with QuickDraw.
clut | Color Look-Up Table. Resource containing the look-up table (palette) used by the Palette Manager. Main default palettes are the B&W palette, the 16 color palette, the icon palette and the 256 color palette. See the palettes displayed by WinComposer on the Palettes Tab.
h8mk | Mask 32*32, 256 transparency levels, length 2304 bytes (0x900).
ich# | Icon 48*48, B&W + mask, length 576 bytes (0x240)
ich4 | Icon 48*48, 16 colors, size 1152 bytes (0x480)
ich8 | Icon 48*48, 256 colors, size 2304 bytes (0x900)
icl4 | Icon 32*32, 16 colors (4 bits), size 512 bytes (0x200)
icl8 | Icon 32*32, 256 colors (8 bits), size 1024 bytes (0x400)
icm# | Mini-icons (12*16), N&B + mask
icm4 | Mini-icons (12*16), 16 colors, 4 bits
icm8 | Mini-icons (12*16), 256 colors, 8 bits
ICN# | Icon 32*32 B&W (1 bit/pixel) + mask, size 256 bytes (2 * 128).
icns | Single resource container containing several icon resources. Under Mac OS X, this icon resource can appear in a file with the *.icns extension.
Icon | Menu icons
ICON | Icons for menus and dialogs, 32*32, B&W, without mask. Always displayed on a white background, therefor no need for a mask.
ics# | Icon 16*16, B&W, length 64 bytes
ics4 | Icon 16*16, 16 colors, size 128 bytes
ics8 | Icon 16*16, 256 colors, size 256 bytes
ih32 | Icon 48*48, 32 bits, variable length (compressed resource).
il32 | Icon 32*32, 32 bits, variable length (compressed resource).
is32 | Icon 16*16, 32 bits, variable length (compressed resource).
it32 | Icon 128*128, 32 bits, variable length (compressed resource).
l8mk | Mask 32*32, 256 transparency levels, size 1024 bytes
s8mk | Mask 16*16, 256 transparency levels, size 256 bytes
SICN | System (S) or small icons. Format 12*16, stored in a 16*16 matrix. The format allows storing any number of icons, but, by convention, there is always a single one (B&W with mask).
t8mk | Mask 128*128, 256 transparency levels, length 0x00004008 (payload 16384)

The Modern icns Resource
Most of above icon resources have a rather historical nature. The current trend is to use exclusively the icns resource. This resource is a container, with several individual icon resources contained within it. The system accesses therefore in a single stroke all necessary icon resources.
This resource kind, which is not known by the old and trusty ResEdit utility (which only displays the hex contents), was introduced with Mac OS 8.5.
For safety reasons, one should always include in the resource file an older ICN# resource, which can be drawn by all versions of the system, even if the probability of being used on an older system is now rather low.
In the same vein, it is probably overkill to include in such a resource the older 4bpp icon resources (16 color palette).
A modern icns resource should therefore contain the ICN# resource and the 32 bpp icons, in 32*32 pixels, 48*48 pixels and maybe 128*128 pixels.

Compression Scheme
The data of 32 bits/pixel icons may be compressed. One should check whether the data length corresponds to the theoretical length (width * height). If not, the data is compressed, channel by channel. The alpha channel is not stored in the data set. It should be recovered from the corresponding ?8mk resource (see the table above).

Pseudocode:
The compression method is not documented by Apple. It was reverse-engineered, probably by Peter Stuer (Peter.Stuer@pandora.be). I used as a basis the code of ResCafé, an exploration utility for Macintosh resources, written in Java by G. Brannon Smith.
For each of the color channels (red, green, blue), and for the maximum length (width * height of the icon), read a byte.
if bit 8 of the byte is set:
   This is a compressed run, for some value (next byte).
   The length is byte - 125.
   Put so many copies of the byte in the current color channel.
Else:
   This is an uncompressed run, whose values follow.
   The length is byte +1.
   Read the bytes and put them in the current color channel.
.


Grouped Saving

Introduction
In its File Menu, WinComposer offers a classical Save function, which applies to all icons displayed in the slots of the Icon Composer tab.

Offered Formats
WinComposer offers to save the icon set in following formats:

  • Macintosh Icons (Data),
  • Macintosh Icons (Resource),
  • Macintosh Icons (Both Forks),
  • Windows Icons.

Why Three Macintosh Icon Formats?
Traditionally, Macintosh icons are stored in the Resource Fork. On the other hand, Mac OS X also uses icons, and more generally resources, which are stored in the Data Fork.
Some icon utilities even save their data as so-called 'fat' files, with the graphic data stored in the data fork and in the resource fork.
Depending on the use you foresee for the resulting file, you'll have to choose between formats. See in particular our page on Custom Icons.

Macintosh Icons (Data)
Icons saved in this file format can only be used under Mac OS X. There is no real difference in the data structure (that is, this data fork, saved as a resource fork, would happily be opened by ResEdit or the Finder under Mac OS 9 and below).
If you intend to use this file as a custom icon for a volume/disk, the name to be used must be '.VolumeIcon.icns' (please note the dot at the beginning).
Back to Top of Page

Macintosh Icons (Resource)
This is the classical file format for Macintosh icons. WinComposer saves the icons as a resource fork stored in a MacBinary container. The name (stored in the MacBinary header) is 'icon\r'.
The resulting file is ready to be used as a custom icon for folders under all versions of Mac OS and for volumes under Mac OS 9 and below.
Back to Top of Page

Macintosh Icons (Both Forks)
It may be useful, in some circumstances, to do both, that is, to save the data twice, one time as a data fork and one time as a resource fork, both stored in a MacBinary container.
Back to Top of Page

Windows Icons
Most icon files, under Windows, contain a single icon. However, the format specification allows to store several sizes and several color depths in a single file.
You could see what is the result by putting this file in a folder and changing the display mode (Thumbnails, Mosaic, Icons, List and Details). In each case, Windows chooses the best format for the display mode.
On the other hand, a single icon (saved through the context-sensitive menu of WinComposer) looks fine at its size (say, 32*32), but becomes ugly when displayed as thumbnails or even before.
Back to Top of Page

See also our page on the Individual Saving of the contents of the selected icon slot.


Individual Saving

Introduction
While WinComposer offers in its File Menu a function to save icons as Icon Sets (collection of several sizes and color depths), it also features, in its context-sensitive menu, an individual saving function for each of the picture slots of the Icon Composer tab.

Selected Icon
The individual saving function works on the selected icon. This icon is displayed with a light green frame.

Offered Formats
WinComposer offers to save the individual icons in following formats:

  • Bitmap File (BMP),
  • JPEG File,
  • icns File (Macintosh icon, data),
  • icns File (Macintosh icon, resource),
  • Windows Icon File (ICO).

Bitmap File (BMP)
The selected icon is saved as a bitmap file (with the *.BMP extension). This format keeps the whole contents of the image (no compression, no loss). You will be able to open and edit this file in all graphic programs.
Back to Top of Page

JPEG File
The selected icon is saved as JPEG file (with the *.JPG extension), with medium compression. The JPEG format uses a lossy compression method, that is the saved image doesn't contain the whole contents displayed in WinComposer.
On the other hand, JPEG files are often much smaller than bitmap files.
Back to Top of Page

icns File (Macintosh icon, data)
The selected icon is saved as an icns resource.
Macintosh icons stored in the data fork can only be used under Mac OS X. On the other hand, there is no difference in the layout and in the contents of the byte stream, which means that the saved contents is the same as with the option below.
Back to Top of Page

icns File (Macintosh icon, resource)
The selected icon is saved as an icns resource.
Traditionally, Macintosh icons are stored in the resource fork.
To protect the resource fork, WinComposer stores it in a MacBinary container. The header of the MacBinary container contains the name which will be used to name the file when it will be unpacked by MacDisk or MacImage.
Back to Top of Page

Windows Icon File (ICO)
The selected icon is saved as a Windows icon file (with the *.ICO extension). There is only one icon in the file, in one size and one color depth.
Back to Top of Page

See also our page on the Grouped Saving of the icons displayed on the Icon Composer tab.